-- SET AUTOTRACE ON
SET TRIMSPOOL ON
SET TRIMOUT   ON
SET WRAP OFF

column DNI1       format A5
column DNI2       format A5
column SERV1      format A5
column SERV2      format A5

-- vista con todas las parejas de usuarios y servicios usados por el primero
CREATE VIEW USO1 (DNI1, DNI2, Serv1) AS
 SELECT DISTINCT C1.DNI, C2.DNI, C1.tpServ
 FROM usoServ C1, usoServ C2
 WHERE C1.DNI < C2.DNI;

SELECT * FROM USO1 ORDER BY DNI1, DNI2, SERV1;

-- vista con todas las parejas de usuarios y servicios usados por el segundo
CREATE VIEW USO2 (DNI1, DNI2, Serv2) AS
 SELECT DISTINCT C1.DNI, C2.DNI, C2.tpServ
 FROM usoServ C1, usoServ C2
 WHERE C1.DNI < C2.DNI;

SELECT * FROM USO2 ORDER BY DNI1, DNI2, SERV2;

-- parejas con servicios usados slo por el primero
SELECT * FROM USO1
MINUS
SELECT * FROM USO2;

-- parejas con servicios usados slo por el segundo
SELECT * FROM USO2
MINUS
SELECT * FROM USO1;


-- vista con todas las parejas de usuarios y servicios compartidos
CREATE VIEW USOC (DNI1, DNI2, Serv) AS
 SELECT DISTINCT C1.DNI, C2.DNI, C1.tpServ
 FROM usoServ C1, usoServ C2
 WHERE C1.DNI < C2.DNI AND C1.tpServ = C2.tpServ;

SELECT * FROM USOC ORDER BY DNI1, DNI2, SERV;


-- todas las parejas que usan exactamente los mismos tipos de servicios
SELECT DNI1, DNI2 FROM USOC
MINUS SELECT DNI1, DNI2 FROM (SELECT * FROM USO2
                              MINUS
                              SELECT * FROM USO1)
MINUS SELECT DNI1, DNI2 FROM (SELECT * FROM USO1
                              MINUS
                              SELECT * FROM USO2);

-- todas las parejas que usan exactamente los mismos tipos de servicios
SELECT DNI1, DNI2 FROM USOC
MINUS SELECT DNI1, DNI2 FROM((SELECT * FROM USO2
                              MINUS
                              SELECT * FROM USO1)
                             UNION
                             (SELECT * FROM USO1
                              MINUS
                              SELECT * FROM USO2));

DROP VIEW USO1;
DROP VIEW USO2;
DROP VIEW USOC;
